# Copyright 2021 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import fields, models, api


class ResPartner(models.Model):
    _inherit = 'res.partner'

    # Company Fields
    membership_number = fields.Integer(
        string='N° Adhérent',
        compute='_compute_membership_number',
        store=True
    )
    membership_contact_id = fields.Many2one(
        comodel_name='res.partner',
        string='Contact Adhésion',
        domain="[('parent_id', '=', id)]"
    )
    membership_mandate_id = fields.Many2one(
        comodel_name='res.partner',
        string='Contact Mandataire',
        domain="[('parent_id', '=', id)]"
    )
    membership_delegate_id = fields.Many2one(
        comodel_name='res.partner',
        string='Contact Délégué',
        domain="[('parent_id', '=', id)]"
    )

    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------
    @api.depends('membership_state')
    def _compute_membership_number(self):
        for partner in self:
            if partner.membership_number == 0 and partner.membership_state != 'none':
                self.membership_number = self.env['ir.sequence'].next_by_code('afac.membership.number')

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
